## mudlet 3.3.1

=== CMakeLists.txt ===
############################################################################
#    Copyright (C) 2014 by Ahmed Charles - acharles@outlook.com            #
#    Copyright (C) 2015-2016 by Stephen Lyons - slysven@virginmedia.com    #
#                                                                          #
#    This program is free software; you can redistribute it and/or modify  #
#    it under the terms of the GNU General Public License as published by  #
#    the Free Software Foundation; either version 2 of the License, or     #
#    (at your option) any later version.                                   #
#                                                                          #
#    This program is distributed in the hope that it will be useful,       #
#    but WITHOUT ANY WARRANTY; without even the implied warranty of        #
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         #
#    GNU General Public License for more details.                          #
#                                                                          #
#    You should have received a copy of the GNU General Public License     #
#    along with this program; if not, write to the                         #
#    Free Software Foundation, Inc.,                                       #
#    59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             #
############################################################################

# Should be called before PROJECT.
CMAKE_MINIMUM_REQUIRED(VERSION 3.1)

PROJECT(mudlet)

IF(CMAKE_CONFIGURATION_TYPES)
  ADD_CUSTOM_TARGET(check COMMAND ${CMAKE_CTEST_COMMAND}
                    --force-new-ctest-process --output-on-failure
                    --build-config "$<CONFIGURATION>")
ELSE()
  ADD_CUSTOM_TARGET(check COMMAND ${CMAKE_CTEST_COMMAND}
                    --force-new-ctest-process --output-on-failure)
ENDIF()

ENABLE_TESTING()

IF(POLICY CMP0020)
  CMAKE_POLICY(SET CMP0020 NEW)
ENDIF()

IF(WIN32)
  SET(APP_TARGET mudlet.exe)
ELSEIF(APPLE)
  SET(APP_TARGET Mudlet)
ELSE()
  SET(APP_TARGET mudlet)
ENDIF()

# APP_BUILD should only be empty/null in official "release" builds,
# developers may like to set the MUDLET_VERSION_BUILD environment variable to
# their user and branch names to make it easier to tell different builds apart!
#
# Changing this pair of values affects: ctelnet.cpp, main.cpp, mudlet.cpp
# dlgAboutDialog.cpp and TLuaInterpreter.cpp.  It will not necessarily cause
# those files to be automatically rebuilt so you may need to 'touch' those files if
# the variables are changed and you are not doing a full, clean, rebuild!
# Use APP_VERSION, APP_BUILD and APP_TARGET defines in the source code if needed.
# IMPORTANT:
# To insure consistency please ensure the SAME of the first two values are also
# assigned to the "VERSION" and "BUILD" variables in the native qmake project
# file, which is NOW called: ./src/mudlet.pro
SET(APP_VERSION 3.3.1)
IF(DEFINED ENV{MUDLET_VERSION_BUILD} AND NOT $ENV{MUDLET_VERSION_BUILD} STREQUAL "")
  SET(APP_BUILD $ENV{MUDLET_VERSION_BUILD})
else()
  SET(APP_BUILD "")
ENDIF()

SET(CMAKE_MODULE_PATH ${CMAKE_CURRENT_SOURCE_DIR}/cmake ${CMAKE_MODULE_PATH})

ADD_SUBDIRECTORY(3rdparty/communi)
ADD_SUBDIRECTORY(3rdparty/lua_yajl)
# Needed (just) on MacOs as an #include in luazip.h:
IF(APPLE)
  ADD_SUBDIRECTORY(3rdparty/luazip)
ENDIF()
ADD_SUBDIRECTORY(3rdparty/edbee-lib/edbee-lib)

ADD_SUBDIRECTORY(src)

=== src/CMakeLists.txt ===
############################################################################
#    Copyright (C) 2014-2017 by Ahmed Charles - acharles@outlook.com       #
#    Copyright (C) 2015-2017 by Stephen Lyons - slysven@virginmedia.com    #
#                                                                          #
#    This program is free software; you can redistribute it and/or modify  #
#    it under the terms of the GNU General Public License as published by  #
#    the Free Software Foundation; either version 2 of the License, or     #
#    (at your option) any later version.                                   #
#                                                                          #
#    This program is distributed in the hope that it will be useful,       #
#    but WITHOUT ANY WARRANTY; without even the implied warranty of        #
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         #
#    GNU General Public License for more details.                          #
#                                                                          #
#    You should have received a copy of the GNU General Public License     #
#    along with this program; if not, write to the                         #
#    Free Software Foundation, Inc.,                                       #
#    59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             #
############################################################################

SET(mudlet_RCCS mudlet.qrc)

SET(mudlet_SRCS
    ActionUnit.cpp
    AliasUnit.cpp
    ctelnet.cpp
    dlgAboutDialog.cpp
    dlgActionMainArea.cpp
    dlgAliasMainArea.cpp
    dlgColorTrigger.cpp
    dlgComposer.cpp
    dlgConnectionProfiles.cpp
    dlgIRC.cpp
    dlgKeysMainArea.cpp
    dlgMapper.cpp
    dlgNotepad.cpp
    dlgPackageExporter.cpp
    dlgProfilePreferences.cpp
    dlgRoomExits.cpp
    dlgScriptsMainArea.cpp
    dlgSourceEditorArea.cpp
    dlgSystemMessageArea.cpp
    dlgTimersMainArea.cpp
    dlgTriggerEditor.cpp
    dlgTriggerPatternEdit.cpp
    dlgTriggersMainArea.cpp
    dlgVarsMainArea.cpp
    EAction.cpp
    exitstreewidget.cpp
    FontManager.cpp
    glwidget.cpp
    Host.cpp
    HostManager.cpp
    KeyUnit.cpp
    LuaInterface.cpp
    main.cpp
    mudlet.cpp
    ScriptUnit.cpp
    T2DMap.cpp
    TAction.cpp
    TAlias.cpp
    TArea.cpp
    TBuffer.cpp
    TCommandLine.cpp
    TConsole.cpp
    TDebug.cpp
    TDockWidget.cpp
    TEasyButtonBar.cpp
    TFlipButton.cpp
    TForkedProcess.cpp
    THighlighter.cpp
    TimerUnit.cpp
    TKey.cpp
    TLabel.cpp
    TLuaInterpreter.cpp
    TMap.cpp
    TriggerUnit.cpp
    TRoom.cpp
    TRoomDB.cpp
    TScript.cpp
    TSplitter.cpp
    TSplitterHandle.cpp
    TTextEdit.cpp
    TTimer.cpp
    TToolBar.cpp
    TTreeWidget.cpp
    TTrigger.cpp
    TVar.cpp
    VarUnit.cpp
    XMLexport.cpp
    XMLimport.cpp
    ircmessageformatter.cpp
)

# This is for compiled UI files, not those used at runtime though the resource file.
SET(mudlet_UIS
    ui/about_dialog.ui
    ui/actions_main_area.ui
    ui/aliases_main_area.ui
    ui/color_trigger.ui
    ui/composer.ui
    ui/connection_profiles.ui
    ui/dlgPackageExporter.ui
    ui/irc.ui
    ui/keybindings_main_area.ui
    ui/main_window.ui
    ui/mapper.ui
    ui/notes_editor.ui
    ui/profile_preferences.ui
    ui/room_exits.ui
    ui/scripts_main_area.ui
    ui/source_editor_area.ui
    ui/system_message_area.ui
    ui/timers_main_area.ui
    ui/triggers_main_area.ui
    ui/trigger_editor.ui
    ui/trigger_pattern_edit.ui
    ui/vars_main_area.ui
)

SET(mudlet_MOC_HDRS 
    ctelnet.h
    dlgAboutDialog.h
    dlgActionMainArea.h
    dlgAliasMainArea.h
    dlgColorTrigger.h
    dlgComposer.h
    dlgConnectionProfiles.h
    dlgIRC.h
    dlgKeysMainArea.h
    dlgMapper.h
    dlgNotepad.h
    dlgPackageExporter.h
    dlgProfilePreferences.h
    dlgRoomExits.h
    dlgScriptsMainArea.h
    dlgSourceEditorArea.h
    dlgSystemMessageArea.h
    dlgTimersMainArea.h
    dlgTriggerEditor.h
    dlgTriggerPatternEdit.h
    dlgTriggersMainArea.h
    dlgVarsMainArea.h
    EAction.h
    exitstreewidget.h
    glwidget.h
    mudlet.h
    T2DMap.h
    TCommandLine.h
    TConsole.h
    TEasyButtonBar.h
    TForkedProcess.h
    THighlighter.h
    TLabel.h
    TLuaInterpreter.h
    TMap.h
    TSplitter.h
    TSplitterHandle.h
    TTextEdit.h
    TToolBar.h
    TTreeWidget.h
)

SET(mudlet_HDRS
    ActionUnit.h
    AliasUnit.h
    FontManager.h
    Host.h
    HostManager.h
    KeyUnit.h
    LuaInterface.h
    pre_guard.h
    post_guard.h
    ScriptUnit.h
    TAction.h
    TAlias.h
    TArea.h
    TAstar.h
    TBuffer.h
    TDebug.h
    TDockWidget.h
    testdbg.h
    TEvent.h
    TFlipButton.h
    TimerUnit.h
    TKey.h
    TMatchState.h
    Tree.h
    TriggerUnit.h
    TRoom.h
    TRoomDB.h
    TScript.h
    TSplitterHandle.h
    TTimer.h
    TTrigger.h
    TVar.h
    VarUnit.h
    XMLexport.h
    XMLimport.h
    ircmessageformatter.h
)

IF(MSVC)
  SET(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -MP") # parallel builds
  SET(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Zc:inline") # improve link times
  SET(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Zc:rvalueCast") # improve conformance
  SET(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -wd4305") # '=' : truncation from 'double' to 'float'
  SET(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -wd4309") # 'initializing' : truncation of constant value
  SET(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -wd4996") # deprecation
ELSE()
  SET(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -fPIC")
  SET(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wno-deprecated")
  IF(APPLE)
    SET(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -stdlib=libc++")
    SET(CMAKE_EXE_LINKER_FLAGS "${CMAKE_EXE_LINKER_FLAGS} -stdlib=libc++")
  ENDIF()
ENDIF()

set(CMAKE_CXX_STANDARD 11)
set(CMAKE_CXX_STANDARD_REQUIRED ON)
set(CMAKE_CXX_EXTENSIONS OFF)

SET(PCRE_DIR "${PROJECT_SOURCE_DIR}/.." CACHE PATH "PCRE install directory.")

SET(YAJL_DIR "${PROJECT_SOURCE_DIR}/.." CACHE PATH "YAJL install directory.")

SET(HUNSPELL_DIR "${PROJECT_SOURCE_DIR}/.." CACHE PATH "HUNSPELL install directory.")

SET(ZIP_DIR "${PROJECT_SOURCE_DIR}/.." CACHE PATH "ZIP install directory.")

IF(EXISTS "${PROJECT_SOURCE_DIR}/../include/lua.h")
  SET(LUA_INCLUDE_DIR_TEMP "${PROJECT_SOURCE_DIR}/../include")
  GET_FILENAME_COMPONENT(LUA_INCLUDE_DIR ${LUA_INCLUDE_DIR_TEMP} ABSOLUTE CACHE)
  IF(EXISTS "${PROJECT_SOURCE_DIR}/../lib/lualib.lib")
    SET(LUA_LIBRARY_RELEASE_TEMP "${PROJECT_SOURCE_DIR}/../lib/lualib.lib")
    GET_FILENAME_COMPONENT(LUA_LIBRARY_RELEASE ${LUA_LIBRARY_RELEASE_TEMP} ABSOLUTE CACHE)
  ENDIF()
  IF(EXISTS "${PROJECT_SOURCE_DIR}/../lib/lualibd.lib")
    SET(LUA_LIBRARY_DEBUG_TEMP "${PROJECT_SOURCE_DIR}/../lib/lualibd.lib")
    GET_FILENAME_COMPONENT(LUA_LIBRARY_DEBUG ${LUA_LIBRARY_DEBUG_TEMP} ABSOLUTE CACHE)
  ENDIF()
  IF(LUA_LIBRARY_DEBUG AND LUA_LIBRARY_RELEASE)
    SET(LUA_LIBRARY optimized ${LUA_LIBRARY_RELEASE} debug ${LUA_LIBRARY_DEBUG} )
  ELSEIF(LUA_LIBRARY_RELEASE)
    SET(LUA_LIBRARY ${LUA_LIBRARY_RELEASE} )
  ELSEIF(LUA_LIBRARY_DEBUG)
    SET(LUA_LIBRARY ${LUA_LIBRARY_DEBUG} )
  ENDIF()
ENDIF()

IF(WIN32)
  IF(EXISTS "${PROJECT_SOURCE_DIR}/../include/zlib.h")
    SET(ZLIB_INCLUDE_DIR_TEMP "${PROJECT_SOURCE_DIR}/../include")
    GET_FILENAME_COMPONENT(ZLIB_INCLUDE_DIR ${ZLIB_INCLUDE_DIR_TEMP} ABSOLUTE CACHE)
    SET(ZLIB_ROOT "${PROJECT_SOURCE_DIR}/..")
    IF(EXISTS "${PROJECT_SOURCE_DIR}/../lib/zlibstat.lib")
      SET(ZLIB_LIBRARY_RELEASE_TEMP "${PROJECT_SOURCE_DIR}/../lib/zlibstat.lib")
      GET_FILENAME_COMPONENT(ZLIB_LIBRARY_RELEASE ${ZLIB_LIBRARY_RELEASE_TEMP} ABSOLUTE CACHE)
    ENDIF()
    IF(EXISTS "${PROJECT_SOURCE_DIR}/../lib/zlibstatd.lib")
      SET(ZLIB_LIBRARY_DEBUG_TEMP "${PROJECT_SOURCE_DIR}/../lib/zlibstatd.lib")
      GET_FILENAME_COMPONENT(ZLIB_LIBRARY_DEBUG ${ZLIB_LIBRARY_DEBUG_TEMP} ABSOLUTE CACHE)
    ENDIF()
    IF(ZLIB_LIBRARY_DEBUG AND ZLIB_LIBRARY_RELEASE)
      SET(ZLIB_LIBRARY optimized ${ZLIB_LIBRARY_RELEASE} debug ${ZLIB_LIBRARY_DEBUG} )
    ELSEIF(ZLIB_LIBRARY_RELEASE)
      SET(ZLIB_LIBRARY ${ZLIB_LIBRARY_RELEASE} )
    ELSEIF(ZLIB_LIBRARY_DEBUG)
      SET(ZLIB_LIBRARY ${ZLIB_LIBRARY_DEBUG} )
    ENDIF()
  ENDIF()
ENDIF()

# Break each step into a separate command so any status message is output straight away
IF(APPLE)
  # The include directory setup for Zip is unusual in that as well as e.g. /usr/include/zip.h
  # we need the path to an interal header zipconf.g that it calls for using '<''>'s
  # i.e. SYSTEM #include delimiters which are typically located at e.g. /usr/lib/libzip/include/zipconf.h
  # and using pkg-config is the recommended way to get the details.
  # Spotted recommendation to use pkg-config here https://github.com/Homebrew/homebrew/issues/13390
  FIND_PACKAGE(PkgConfig)
  IF(NOT(PKG_CONFIG_FOUND))
    MESSAGE(WARNING "Unable to use pkg_config - will possibly fail to find/use Zip library...")
  ENDIF()
ENDIF()

IF((APPLE) AND (PKG_CONFIG_FOUND))
  PKG_SEARCH_MODULE(PC_ZIP zip libzip)
  # Use a PC_ prefix to distinguish between what pkg-config finds and a direct use of FIND_PACKAGE(ZIP)
  # Package "zip" is called "libzip" at least on MY Linux box so look for BOTH
  IF(PC_ZIP_FOUND)
    IF(PC_ZIP_zip_FOUND)
      MESSAGE(STATUS "Using pkg_config, found \"zip\" version: ${PC_ZIP_zip_VERSION} with:")
    ELSEIF(PC_ZIP_libzip_FOUND)
      MESSAGE(STATUS "Using pkg_config, found \"libzip\" version: ${PC_ZIP_libzip_VERSION} with:")
    ELSE()
      MESSAGE(STATUS "Using pkg_config, found Zip version: ${PC_ZIP_VERSION} with:")
    ENDIF()
    MESSAGE(STATUS "  include directory(ies), ZIP_INCLUDE_DIRS: ${PC_ZIP_INCLUDE_DIRS} .")
    MESSAGE(STATUS "  library(ies): ZIP_LIBRARY_DIRS: ${PC_ZIP_LIBRARY_DIRS}; ZIP_LIBDIR: ${PC_ZIP_LIBDIR}. ")
  ELSE()
    MESSAGE(WARNING "Using pkg_config, failed to find any version of Zip library!")
  ENDIF()
ENDIF()

IF((APPLE) AND (PKG_CONFIG_FOUND))
  PKG_SEARCH_MODULE(PC_HUNSPELL hunspell libhunspell)
  IF(PC_HUNSPELL_FOUND)
    IF(PC_HUNSPELL_hunspell_FOUND)
      MESSAGE(STATUS "Using pkg_config, found \"hunspell\" version: ${PC_HUNSPELL_hunspell_VERSION} with:")
    ELSEIF(PC_HUNSPELL_libhunspell_FOUND)
      MESSAGE(STATUS "Using pkg_config, found \"libhunspell\" version: ${PC_HUNSPELL_libhunspell_VERSION} with:")
    ELSE()
      MESSAGE(STATUS "Using pkg_config, found Hunspell version: ${PC_HUNSPELL_VERSION} with:")
    ENDIF()
    MESSAGE(STATUS "  include directory(ies), HUNSPELL_INCLUDE_DIRS: ${PC_HUNSPELL_INCLUDE_DIRS} .")
    MESSAGE(STATUS "  library(ies): HUNSPELL_LIBRARY_DIRS: ${PC_HUNSPELL_LIBRARY_DIRS}; HUNSPELL_LIBRARY_DIR: ${PC_HUNSPELL_LIBRARY_DIR}. ")
  ELSEIF()
    MESSAGE(WARNING "Using pkg_config, failed to find any version of Hunspell library!")
  ENDIF()
ENDIF()

FIND_PACKAGE(Qt5Core REQUIRED)
IF (Qt5Core_VERSION VERSION_LESS 5.6)
  message(FATAL_ERROR "Mudlet requires Qt 5.6 or later")
ELSE()
  message(STATUS "Qt version: ${Qt5Core_VERSION}")
ENDIF()

FIND_PACKAGE(Qt5Multimedia REQUIRED)
FIND_PACKAGE(Qt5Network REQUIRED)
FIND_PACKAGE(Qt5OpenGL REQUIRED)
FIND_PACKAGE(Qt5UiTools REQUIRED)
FIND_PACKAGE(Qt5Widgets REQUIRED)
FIND_PACKAGE(Qt5 COMPONENTS Concurrent)
FIND_PACKAGE(Qt5Concurrent REQUIRED)

IF(WIN32)
  SET(mudlet_RC_ICONS = icons/mudlet_main_512x512_6XS_icon.ico)
  QT5_ADD_RESOURCES(RC_ICONS ${mudlet_RC_ICONS})
ENDIF()

IF(NOT(PC_ZIP_FOUND))
  FIND_PACKAGE(ZIP REQUIRED)
ENDIF()
FIND_PACKAGE(OpenGL REQUIRED)
FIND_PACKAGE(Lua51 REQUIRED)
FIND_PACKAGE(ZLIB REQUIRED)
FIND_PACKAGE(PCRE REQUIRED)
FIND_PACKAGE(YAJL REQUIRED)

# Fall back on original FIND_PACKAGE process on Apple if Package Config failed
# Originally we did use that but it started to fail on Travis C.I. in June 2016
# So we now try to use PackageConfig for MacOs platform
IF(APPLE)
  IF(NOT(PC_HUNSPELL_FOUND))
    FIND_PACKAGE(HUNSPELL REQUIRED)
  ENDIF()
ELSE()
  FIND_PACKAGE(HUNSPELL REQUIRED)
ENDIF()

FIND_PACKAGE(Boost 1.44 COMPONENTS graph)

=== 3rdparty/communi/CMakeLists.txt ===
############################################################################
# Communi                                                                  #
#                                                                          #
#    Copyright (C) 2014-2017 by Ahmed Charles - acharles@outlook.com       #
#                                                                          #
#    This program is free software; you can redistribute it and/or modify  #
#    it under the terms of the GNU General Public License as published by  #
#    the Free Software Foundation; either version 2 of the License, or     #
#    (at your option) any later version.                                   #
#                                                                          #
#    This program is distributed in the hope that it will be useful,       #
#    but WITHOUT ANY WARRANTY; without even the implied warranty of        #
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         #
#    GNU General Public License for more details.                          #
#                                                                          #
#    You should have received a copy of the GNU General Public License     #
#    along with this program; if not, write to the                         #
#    Free Software Foundation, Inc.,                                       #
#    59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             #
############################################################################

IF(POLICY CMP0020)
  CMAKE_POLICY(SET CMP0020 NEW)
ENDIF()

PROJECT(communi)

FIND_PACKAGE(Qt5Core REQUIRED)
FIND_PACKAGE(Qt5Network REQUIRED)

INCLUDE_DIRECTORIES(
  ${CMAKE_CURRENT_SOURCE_DIR}/include/IrcCore
  ${CMAKE_CURRENT_SOURCE_DIR}/include/IrcModel
  ${CMAKE_CURRENT_SOURCE_DIR}/include/IrcUtil
)

SET(SRCS
  src/core/irc.cpp
  src/core/irccommand.cpp
  src/core/ircconnection.cpp
  src/core/irccore.cpp
  src/core/ircfilter.cpp
  src/core/ircmessage.cpp
  src/core/ircmessage_p.cpp
  src/core/ircmessagecomposer.cpp
  src/core/ircmessagedecoder.cpp
  src/core/ircmessagedecoder_none.cpp
  src/core/ircnetwork.cpp
  src/core/ircprotocol.cpp
  src/3rdparty/mozilla/rdf_utils.c
  src/model/ircbuffer.cpp
  src/model/ircbuffermodel.cpp
  src/model/ircchannel.cpp
  src/model/ircmodel.cpp
  src/model/ircuser.cpp
  src/model/ircusermodel.cpp
  src/util/irccommandparser.cpp
  src/util/irccommandqueue.cpp
  src/util/irccompleter.cpp
  src/util/irclagtimer.cpp
  src/util/ircpalette.cpp
  src/util/irctextformat.cpp
  src/util/irctoken.cpp
  src/util/ircutil.cpp
)
SET(HDRS
  include/IrcCore/irccommand_p.h
  include/IrcCore/ircconnection_p.h
  include/IrcCore/ircdebug_p.h
  include/IrcCore/ircmessage_p.h
  include/IrcCore/ircmessagecomposer_p.h
  include/IrcCore/ircmessagedecoder_p.h
  include/IrcCore/ircnetwork_p.h
  include/IrcModel/ircuser_p.h
  include/IrcModel/ircbuffer_p.h
  include/IrcModel/ircchannel_p.h
  include/IrcModel/ircusermodel_p.h
  include/IrcModel/ircbuffermodel_p.h
  include/IrcUtil/irctoken_p.h
  include/IrcUtil/irclagtimer_p.h
  include/IrcUtil/irccommandqueue_p.h
  include/IrcUtil/irccommandparser_p.h
)
SET(MOC_HDRS
  include/IrcCore/irc.h
  include/IrcCore/irccommand.h
  include/IrcCore/ircconnection.h
  include/IrcCore/ircmessage.h
  include/IrcCore/ircnetwork.h
  include/IrcCore/ircprotocol.h
  include/IrcModel/ircbuffer.h
  include/IrcModel/ircbuffermodel.h
  include/IrcModel/ircchannel.h
  include/IrcModel/ircmodel.h
  include/IrcModel/ircuser.h
  include/IrcModel/ircusermodel.h
  include/IrcUtil/irccommandparser.h
  include/IrcUtil/irccommandqueue.h
  include/IrcUtil/irccompleter.h
  include/IrcUtil/irclagtimer.h
  include/IrcUtil/ircpalette.h
  include/IrcUtil/irctextformat.h
  include/IrcUtil/ircutil.h
)
SET(PUB_HDRS
  ${MOC_HDRS}
  include/IrcCore/irccore.h
  include/IrcCore/ircfilter.h
  include/IrcCore/ircglobal.h
  include/IrcCore/Irc
  include/IrcCore/IrcCommand
  include/IrcCore/IrcCommandFilter
  include/IrcCore/IrcConnection
  include/IrcCore/IrcCore
  include/IrcCore/IrcGlobal
  include/IrcCore/IrcMessage
  include/IrcCore/IrcMessageFilter
  include/IrcCore/IrcNetwork
  include/IrcCore/IrcProtocol
  include/IrcModel/IrcBuffer
  include/IrcModel/IrcBufferModel
  include/IrcModel/IrcChannel
  include/IrcModel/IrcModel
  include/IrcModel/IrcUser
  include/IrcModel/IrcUserModel
  include/IrcUtil/IrcCommandParser
  include/IrcUtil/IrcCommandQueue
  include/IrcUtil/IrcCompleter
  include/IrcUtil/IrcLagTimer
  include/IrcUtil/IrcPalette
  include/IrcUtil/IrcTextFormat
  include/IrcUtil/IrcUtil
)

QT5_GENERATE_MOC(include/IrcCore/irc.h ${CMAKE_CURRENT_BINARY_DIR}/IrcCore/moc_irc.cpp)
QT5_GENERATE_MOC(include/IrcCore/irccommand.h ${CMAKE_CURRENT_BINARY_DIR}/IrcCore/moc_irccommand.cpp)
QT5_GENERATE_MOC(include/IrcCore/ircconnection.h ${CMAKE_CURRENT_BINARY_DIR}/IrcCore/moc_ircconnection.cpp)
QT5_GENERATE_MOC(include/IrcCore/ircmessage.h ${CMAKE_CURRENT_BINARY_DIR}/IrcCore/moc_ircmessage.cpp)
QT5_GENERATE_MOC(include/IrcCore/ircmessagecomposer_p.h ${CMAKE_CURRENT_BINARY_DIR}/IrcCore/moc_ircmessagecomposer_p.cpp)
QT5_GENERATE_MOC(include/IrcCore/ircnetwork.h ${CMAKE_CURRENT_BINARY_DIR}/IrcCore/moc_ircnetwork.cpp)
QT5_GENERATE_MOC(include/IrcCore/ircprotocol.h ${CMAKE_CURRENT_BINARY_DIR}/IrcCore/moc_ircprotocol.cpp)
QT5_GENERATE_MOC(include/IrcModel/ircusermodel.h ${CMAKE_CURRENT_BINARY_DIR}/IrcModel/moc_ircusermodel.cpp)
QT5_GENERATE_MOC(include/IrcModel/ircchannel.h ${CMAKE_CURRENT_BINARY_DIR}/IrcModel/moc_ircchannel.cpp)
QT5_GENERATE_MOC(include/IrcModel/ircbuffer.h ${CMAKE_CURRENT_BINARY_DIR}/IrcModel/moc_ircbuffer.cpp)
QT5_GENERATE_MOC(include/IrcModel/ircbuffermodel_p.h ${CMAKE_CURRENT_BINARY_DIR}/IrcModel/moc_ircbuffermodel_p.cpp)
QT5_GENERATE_MOC(include/IrcModel/ircbuffermodel.h ${CMAKE_CURRENT_BINARY_DIR}/IrcModel/moc_ircbuffermodel.cpp)
QT5_GENERATE_MOC(include/IrcModel/ircuser.h ${CMAKE_CURRENT_BINARY_DIR}/IrcModel/moc_ircuser.cpp)
QT5_GENERATE_MOC(include/IrcModel/ircusermodel.h ${CMAKE_CURRENT_BINARY_DIR}/IrcModel/moc_ircusermodel.cpp)
QT5_GENERATE_MOC(include/IrcUtil/irccompleter.h ${CMAKE_CURRENT_BINARY_DIR}/IrcUtil/moc_irccompleter.cpp)
QT5_GENERATE_MOC(include/IrcUtil/irccommandparser.h ${CMAKE_CURRENT_BINARY_DIR}/IrcUtil/moc_irccommandparser.cpp)
QT5_GENERATE_MOC(include/IrcUtil/irccommandqueue.h ${CMAKE_CURRENT_BINARY_DIR}/IrcUtil/moc_irccommandqueue.cpp)
QT5_GENERATE_MOC(include/IrcUtil/irccommandqueue_p.h ${CMAKE_CURRENT_BINARY_DIR}/IrcUtil/moc_irccommandqueue_p.cpp)
QT5_GENERATE_MOC(include/IrcUtil/irclagtimer.h ${CMAKE_CURRENT_BINARY_DIR}/IrcUtil/moc_irclagtimer.cpp)
QT5_GENERATE_MOC(include/IrcUtil/irclagtimer_p.h ${CMAKE_CURRENT_BINARY_DIR}/IrcUtil/moc_irclagtimer_p.cpp)
QT5_GENERATE_MOC(include/IrcUtil/irctextformat.h ${CMAKE_CURRENT_BINARY_DIR}/IrcUtil/moc_irctextformat.cpp)
QT5_GENERATE_MOC(include/IrcUtil/ircpalette.h ${CMAKE_CURRENT_BINARY_DIR}/IrcUtil/moc_ircpalette.cpp)

SET_PROPERTY(SOURCE src/core/irc.cpp
  APPEND PROPERTY OBJECT_DEPENDS ${CMAKE_CURRENT_BINARY_DIR}/IrcCore/moc_irc.cpp)
SET_PROPERTY(SOURCE src/core/irccommand.cpp
  APPEND PROPERTY OBJECT_DEPENDS ${CMAKE_CURRENT_BINARY_DIR}/IrcCore/moc_irccommand.cpp)
SET_PROPERTY(SOURCE src/core/ircconnection.cpp
  APPEND PROPERTY OBJECT_DEPENDS ${CMAKE_CURRENT_BINARY_DIR}/IrcCore/moc_ircconnection.cpp)
SET_PROPERTY(SOURCE src/core/ircmessage.cpp
  APPEND PROPERTY OBJECT_DEPENDS ${CMAKE_CURRENT_BINARY_DIR}/IrcCore/moc_ircmessage.cpp)
SET_PROPERTY(SOURCE src/core/ircmessagecomposer.cpp
  APPEND PROPERTY OBJECT_DEPENDS ${CMAKE_CURRENT_BINARY_DIR}/IrcCore/moc_ircmessagecomposer_p.cpp)
SET_PROPERTY(SOURCE src/core/ircnetwork.cpp
  APPEND PROPERTY OBJECT_DEPENDS ${CMAKE_CURRENT_BINARY_DIR}/IrcCore/moc_ircnetwork.cpp)
SET_PROPERTY(SOURCE src/core/ircprotocol.cpp
  APPEND PROPERTY OBJECT_DEPENDS ${CMAKE_CURRENT_BINARY_DIR}/IrcCore/moc_ircprotocol.cpp)
SET_PROPERTY(SOURCE src/model/ircusermodel.cpp
  APPEND PROPERTY OBJECT_DEPENDS ${CMAKE_CURRENT_BINARY_DIR}/IrcModel/moc_ircusermodel.cpp)
SET_PROPERTY(SOURCE src/model/ircchannel.cpp
  APPEND PROPERTY OBJECT_DEPENDS ${CMAKE_CURRENT_BINARY_DIR}/IrcModel/moc_ircchannel.cpp)
SET_PROPERTY(SOURCE src/model/ircbuffer.cpp
  APPEND PROPERTY OBJECT_DEPENDS ${CMAKE_CURRENT_BINARY_DIR}/IrcModel/moc_ircbuffer.cpp)
SET_PROPERTY(SOURCE src/model/ircbuffermodel.cpp 
  APPEND PROPERTY OBJECT_DEPENDS ${CMAKE_CURRENT_BINARY_DIR}/IrcModel/moc_ircbuffermodel.cpp)
SET_PROPERTY(SOURCE src/model/ircbuffermodel.cpp 
  APPEND PROPERTY OBJECT_DEPENDS ${CMAKE_CURRENT_BINARY_DIR}/IrcModel/moc_ircbuffermodel_p.cpp)
SET_PROPERTY(SOURCE src/model/ircuser.cpp
  APPEND PROPERTY OBJECT_DEPENDS ${CMAKE_CURRENT_BINARY_DIR}/IrcModel/moc_ircuser.cpp)
SET_PROPERTY(SOURCE src/model/ircusermodel.cpp 
  APPEND PROPERTY OBJECT_DEPENDS ${CMAKE_CURRENT_BINARY_DIR}/IrcModel/moc_ircusermodel.cpp)
SET_PROPERTY(SOURCE src/util/irccompleter.cpp
  APPEND PROPERTY OBJECT_DEPENDS ${CMAKE_CURRENT_BINARY_DIR}/IrcUtil/moc_irccompleter.cpp)
SET_PROPERTY(SOURCE src/util/irccommandparser.cpp
  APPEND PROPERTY OBJECT_DEPENDS ${CMAKE_CURRENT_BINARY_DIR}/IrcUtil/moc_irccommandparser.cpp)
SET_PROPERTY(SOURCE src/util/irccommandqueue.cpp
  APPEND PROPERTY OBJECT_DEPENDS ${CMAKE_CURRENT_BINARY_DIR}/IrcUtil/moc_irccommandqueue.cpp)
SET_PROPERTY(SOURCE src/util/irccommandqueue.cpp
  APPEND PROPERTY OBJECT_DEPENDS ${CMAKE_CURRENT_BINARY_DIR}/IrcUtil/moc_irccommandqueue_p.cpp)
SET_PROPERTY(SOURCE src/util/irclagtimer.cpp
  APPEND PROPERTY OBJECT_DEPENDS ${CMAKE_CURRENT_BINARY_DIR}/IrcUtil/moc_irclagtimer.cpp)
SET_PROPERTY(SOURCE src/util/irclagtimer.cpp
  APPEND PROPERTY OBJECT_DEPENDS ${CMAKE_CURRENT_BINARY_DIR}/IrcUtil/moc_irclagtimer_p.cpp)
SET_PROPERTY(SOURCE src/util/irctextformat.cpp
  APPEND PROPERTY OBJECT_DEPENDS ${CMAKE_CURRENT_BINARY_DIR}/IrcUtil/moc_irctextformat.cpp)
SET_PROPERTY(SOURCE src/util/ircpalette.cpp
  APPEND PROPERTY OBJECT_DEPENDS ${CMAKE_CURRENT_BINARY_DIR}/IrcUtil/moc_ircpalette.cpp)

ADD_LIBRARY(communi STATIC ${SRCS} ${HDRS} ${PUB_HDRS})

TARGET_LINK_LIBRARIES(communi ${Qt5Core_LIBRARIES} ${Qt5Network_LIBRARIES})

TARGET_INCLUDE_DIRECTORIES(communi PRIVATE
  ${CMAKE_CURRENT_BINARY_DIR}/IrcCore
  ${CMAKE_CURRENT_BINARY_DIR}/IrcModel
  ${CMAKE_CURRENT_BINARY_DIR}/IrcUtil
)
TARGET_INCLUDE_DIRECTORIES(communi PUBLIC
  ${Qt5Core_INCLUDE_DIRS}
  ${Qt5Network_INCLUDE_DIRS}
  ${CMAKE_CURRENT_SOURCE_DIR}/include/IrcCore
  ${CMAKE_CURRENT_SOURCE_DIR}/include/IrcModel
  ${CMAKE_CURRENT_SOURCE_DIR}/include/IrcUtil
)

=== 3rdparty/lua_yajl/CMakeLists.txt ===
PROJECT(lua_yajl LANGUAGES C)

FIND_PACKAGE(Lua51 REQUIRED)
FIND_PACKAGE(YAJL REQUIRED)

ADD_LIBRARY(lua_yajl STATIC lua_yajl.c)

TARGET_LINK_LIBRARIES(lua_yajl ${LUA_LIBRARIES} ${YAJL_LIBRARIES})

TARGET_INCLUDE_DIRECTORIES(lua_yajl PRIVATE
  ${LUA_INCLUDE_DIR}
  ${YAJL_INCLUDE_DIR}
)

=== 3rdparty/edbee-lib/edbee-lib/CMakeLists.txt ===
# Should be called before PROJECT.
CMAKE_MINIMUM_REQUIRED(VERSION 3.1)

IF(POLICY CMP0020)
  CMAKE_POLICY(SET CMP0020 NEW)
ENDIF()

PROJECT(edbee-lib)

SET(SOURCES
   edbee/util/mem/debug_new.cpp 
   edbee/util/mem/debug_allocs.cpp 
   edbee/util/simpleprofiler.cpp 
   edbee/util/textcodecdetector.cpp 
   edbee/util/lineending.cpp 
   edbee/texteditorwidget.cpp 
   edbee/views/textrenderer.cpp 
   edbee/models/textdocument.cpp 
   edbee/models/chardocument/chartextdocument.cpp 
   edbee/models/texteditorconfig.cpp 
   edbee/models/texteditorkeymap.cpp 
   edbee/models/textundostack.cpp 
   edbee/views/textcaretcache.cpp 
   edbee/models/textlexer.cpp 
   edbee/models/textrange.cpp 
   edbee/views/textselection.cpp 
   edbee/models/textdocumentscopes.cpp 
   edbee/lexers/grammartextlexer.cpp 
   edbee/util/gapvector.h 
   edbee/util/lineoffsetvector.cpp 
   edbee/models/textlinedata.cpp 
   edbee/models/textbuffer.cpp 
   edbee/models/chardocument/chartextbuffer.cpp 
   edbee/texteditorcontroller.cpp 
   edbee/texteditorcommand.cpp 
   edbee/commands/selectioncommand.cpp 
   edbee/commands/undocommand.cpp 
   edbee/commands/redocommand.cpp 
   edbee/commands/replaceselectioncommand.cpp 
   edbee/commands/copycommand.cpp 
   edbee/commands/cutcommand.cpp 
   edbee/commands/pastecommand.cpp 
   edbee/io/textdocumentserializer.cpp 
   edbee/util/test.cpp 
   edbee/util/textcodec.cpp 
   edbee/io/tmlanguageparser.cpp 
   edbee/commands/debugcommand.cpp 
   edbee/util/regexp.cpp 
   edbee/io/tmthemeparser.cpp 
   edbee/io/baseplistparser.cpp 
   edbee/io/jsonparser.cpp 
   edbee/models/textgrammar.cpp 
   edbee/models/texteditorcommandmap.cpp 
   edbee/views/components/texteditorcomponent.cpp 
   edbee/views/components/texteditorrenderer.cpp 
   edbee/views/components/textmargincomponent.cpp 
   edbee/views/texttheme.cpp 
   edbee/views/texteditorscrollarea.cpp 
   edbee/models/textsearcher.cpp 
   edbee/commands/findcommand.cpp 
   edbee/io/keymapparser.cpp 
   edbee/commands/tabcommand.cpp 
   edbee/edbee.cpp 
   edbee/models/textdocumentfilter.cpp 
   edbee/util/cascadingqvariantmap.cpp 
   edbee/commands/duplicatecommand.cpp 
   edbee/commands/newlinecommand.cpp 
   edbee/util/util.cpp 
   edbee/commands/removecommand.cpp 
   edbee/models/change.cpp 
   edbee/models/changes/abstractrangedchange.cpp 
   edbee/models/changes/linedatalistchange.cpp 
   edbee/models/changes/linedatachange.cpp 
   edbee/models/changes/selectionchange.cpp 
   edbee/models/changes/textchange.cpp 
   edbee/models/changes/textchangewithcaret.cpp 
   edbee/models/changes/mergablechangegroup.cpp 
   edbee/commands/commentcommand.cpp 
   edbee/util/rangesetlineiterator.cpp 
   edbee/models/dynamicvariables.cpp 
   edbee/util/rangelineiterator.cpp 
   edbee/data/factorykeymap.cpp 
   edbee/data/factorycommandmap.cpp
)

SET(HEADERS
   edbee/util/logging.h 
   edbee/util/mem/debug_new.h 
   edbee/util/mem/debug_allocs.h 
   edbee/util/simpleprofiler.h 
   edbee/util/textcodecdetector.h 
   edbee/util/lineending.h 
   edbee/texteditorwidget.h 
   edbee/views/textrenderer.h 
   edbee/models/textdocument.h 
   edbee/models/chardocument/chartextdocument.h 
   edbee/models/texteditorconfig.h 
   edbee/models/texteditorkeymap.h 
   edbee/models/textundostack.h 
   edbee/texteditorcontroller.h 
   edbee/views/textcaretcache.h 
   edbee/models/textlexer.h 
   edbee/models/textrange.h 
   edbee/views/textselection.h 
   edbee/models/textdocumentscopes.h 
   edbee/lexers/grammartextlexer.h 
   edbee/util/lineoffsetvector.h 
   edbee/models/textlinedata.h 
   edbee/models/textbuffer.h 
   edbee/models/chardocument/chartextbuffer.h 
   edbee/texteditorcommand.h 
   edbee/commands/selectioncommand.h 
   edbee/commands/undocommand.h 
   edbee/commands/redocommand.h 
   edbee/commands/replaceselectioncommand.h 
   edbee/commands/copycommand.h 
   edbee/commands/cutcommand.h 
   edbee/commands/pastecommand.h 
   edbee/models/textdocumentfilter.h 
   edbee/debug.h 
   edbee/io/textdocumentserializer.h 
   edbee/util/test.h 
   edbee/util/textcodec.h 
   edbee/io/tmlanguageparser.h 
   edbee/commands/debugcommand.h 
   edbee/util/regexp.h 
   edbee/io/tmthemeparser.h 
   edbee/io/baseplistparser.h 
   edbee/io/jsonparser.h 
   edbee/models/textgrammar.h 
   edbee/models/texteditorcommandmap.h 
   edbee/views/components/texteditorcomponent.h 
   edbee/views/components/texteditorrenderer.h 
   edbee/views/components/textmargincomponent.h 
   edbee/views/texttheme.h 
   edbee/views/texteditorscrollarea.h 
   edbee/models/textsearcher.h 
   edbee/commands/findcommand.h 
   edbee/io/keymapparser.h 
   edbee/commands/tabcommand.h 
   edbee/edbee.h 
   edbee/util/cascadingqvariantmap.h 
   edbee/commands/duplicatecommand.h 
   edbee/commands/newlinecommand.h 
   edbee/util/util.h 
   edbee/commands/removecommand.h 
   edbee/models/change.h 
   edbee/models/changes/abstractrangedchange.h 
   edbee/models/changes/linedatalistchange.h 
   edbee/models/changes/linedatachange.h 
   edbee/models/changes/selectionchange.h 
   edbee/models/changes/textchange.h 
   edbee/models/changes/textchangewithcaret.h 
   edbee/models/changes/mergablechangegroup.h 
   edbee/commands/commentcommand.h 
   edbee/util/rangesetlineiterator.h 
   edbee/models/dynamicvariables.h 
   edbee/util/rangelineiterator.h 
   edbee/data/factorykeymap.h 
   edbee/data/factorycommandmap.h
) 

FIND_PACKAGE(Qt5Core REQUIRED)
FIND_PACKAGE(Qt5UiTools REQUIRED)
FIND_PACKAGE(Qt5Widgets REQUIRED)

IF(Qt5_POSITION_INDEPENDENT_CODE)
  SET(CMAKE_POSITION_INDEPENDENT_CODE ON)
ENDIF()

set(CMAKE_AUTOMOC ON)

add_subdirectory(../vendor/qslog/ qslog)
add_subdirectory(../vendor/onig/ onig)

ADD_DEFINITIONS(
    ${Qt5Core_DEFINITIONS}
    ${Qt5UiTools_DEFINTIONS}
    ${Qt5Widgets_DEFINTIONS}
)


SET(CMAKE_INCLUDE_CURRENT_DIR ON)
INCLUDE_DIRECTORIES(
    ${Qt5Core_INCLUDE_DIRS}
    ${Qt5UiTools_INCLUDE_DIRS}
    ${Qt5Widgets_INCLUDE_DIRS}
    ${QS_LOG_INCLUDE_DIRS}
    ${ONIG_INCLUDE_DIRS}
)

ADD_LIBRARY(edbee-lib STATIC
  ${SOURCES} ${HEADERS} ${QS_LOG_SOURCES} ${QS_LOG_HEADERS} ${ONIG_SOURCES}
  ${ONIG_HEADERS})

TARGET_INCLUDE_DIRECTORIES(edbee-lib PUBLIC
  ${Qt5Core_INCLUDE_DIRS}
  ${Qt5UiTools_INCLUDE_DIRS}
  ${Qt5Widgets_INCLUDE_DIRS}
  ${QS_LOG_INCLUDE_DIRS}
  ${ONIG_INCLUDE_DIRS}
  ${CMAKE_CURRENT_SOURCE_DIR}
)

SET_PROPERTY(TARGET edbee-lib PROPERTY CXX_STANDARD 11)

=== 3rdparty/edbee-lib/vendor/onig/CMakeLists.txt ===
SET(ONIG_INCLUDE_DIRS
  ${CMAKE_CURRENT_SOURCE_DIR}/
  ${CMAKE_CURRENT_SOURCE_DIR}/enc/unicode
  PARENT_SCOPE
)

SET(ONIG_SOURCES
           ${CMAKE_CURRENT_SOURCE_DIR}/regcomp.c 
           ${CMAKE_CURRENT_SOURCE_DIR}/regenc.c 
           ${CMAKE_CURRENT_SOURCE_DIR}/regerror.c 
           ${CMAKE_CURRENT_SOURCE_DIR}/regexec.c 
           ${CMAKE_CURRENT_SOURCE_DIR}/regext.c 
           ${CMAKE_CURRENT_SOURCE_DIR}/reggnu.c 
           ${CMAKE_CURRENT_SOURCE_DIR}/regparse.c 
           ${CMAKE_CURRENT_SOURCE_DIR}/regposerr.c 
           ${CMAKE_CURRENT_SOURCE_DIR}/regposix.c 
           ${CMAKE_CURRENT_SOURCE_DIR}/regsyntax.c 
           ${CMAKE_CURRENT_SOURCE_DIR}/regtrav.c 
           ${CMAKE_CURRENT_SOURCE_DIR}/regversion.c 
           ${CMAKE_CURRENT_SOURCE_DIR}/st.c 
           ${CMAKE_CURRENT_SOURCE_DIR}/enc/ascii.c 
           ${CMAKE_CURRENT_SOURCE_DIR}/enc/big5.c 
           ${CMAKE_CURRENT_SOURCE_DIR}/enc/cp949.c 
           ${CMAKE_CURRENT_SOURCE_DIR}/enc/emacs_mule.c 
           ${CMAKE_CURRENT_SOURCE_DIR}/enc/euc_jp.c 
           ${CMAKE_CURRENT_SOURCE_DIR}/enc/euc_kr.c 
           ${CMAKE_CURRENT_SOURCE_DIR}/enc/euc_tw.c 
           ${CMAKE_CURRENT_SOURCE_DIR}/enc/gb18030.c 
           ${CMAKE_CURRENT_SOURCE_DIR}/enc/gbk.c 
           ${CMAKE_CURRENT_SOURCE_DIR}/enc/iso_8859.h 
           ${CMAKE_CURRENT_SOURCE_DIR}/enc/iso_8859_1.c 
           ${CMAKE_CURRENT_SOURCE_DIR}/enc/iso_8859_10.c 
           ${CMAKE_CURRENT_SOURCE_DIR}/enc/iso_8859_11.c 
           ${CMAKE_CURRENT_SOURCE_DIR}/enc/iso_8859_13.c 
           ${CMAKE_CURRENT_SOURCE_DIR}/enc/iso_8859_14.c 
           ${CMAKE_CURRENT_SOURCE_DIR}/enc/iso_8859_15.c 
           ${CMAKE_CURRENT_SOURCE_DIR}/enc/iso_8859_16.c 
           ${CMAKE_CURRENT_SOURCE_DIR}/enc/iso_8859_2.c 
           ${CMAKE_CURRENT_SOURCE_DIR}/enc/iso_8859_3.c 
           ${CMAKE_CURRENT_SOURCE_DIR}/enc/iso_8859_4.c 
           ${CMAKE_CURRENT_SOURCE_DIR}/enc/iso_8859_5.c 
           ${CMAKE_CURRENT_SOURCE_DIR}/enc/iso_8859_6.c 
           ${CMAKE_CURRENT_SOURCE_DIR}/enc/iso_8859_7.c 
           ${CMAKE_CURRENT_SOURCE_DIR}/enc/iso_8859_8.c 
           ${CMAKE_CURRENT_SOURCE_DIR}/enc/iso_8859_9.c 
           ${CMAKE_CURRENT_SOURCE_DIR}/enc/koi8_r.c 
           ${CMAKE_CURRENT_SOURCE_DIR}/enc/koi8_u.c 
           ${CMAKE_CURRENT_SOURCE_DIR}/enc/shift_jis.c 
           ${CMAKE_CURRENT_SOURCE_DIR}/enc/unicode.c 
           ${CMAKE_CURRENT_SOURCE_DIR}/enc/us_ascii.c 
           ${CMAKE_CURRENT_SOURCE_DIR}/enc/utf_16be.c 
           ${CMAKE_CURRENT_SOURCE_DIR}/enc/utf_16le.c 
           ${CMAKE_CURRENT_SOURCE_DIR}/enc/utf_32be.c 
           ${CMAKE_CURRENT_SOURCE_DIR}/enc/utf_32le.c 
           ${CMAKE_CURRENT_SOURCE_DIR}/enc/utf_8.c 
           ${CMAKE_CURRENT_SOURCE_DIR}/enc/windows_1250.c 
           ${CMAKE_CURRENT_SOURCE_DIR}/enc/windows_1251.c 
           ${CMAKE_CURRENT_SOURCE_DIR}/enc/windows_1252.c 
           ${CMAKE_CURRENT_SOURCE_DIR}/enc/windows_1253.c 
           ${CMAKE_CURRENT_SOURCE_DIR}/enc/windows_1254.c 
           ${CMAKE_CURRENT_SOURCE_DIR}/enc/windows_1257.c 
           ${CMAKE_CURRENT_SOURCE_DIR}/enc/windows_31j.c
           PARENT_SCOPE
)

SET(ONIG_HEADERS
           ${CMAKE_CURRENT_SOURCE_DIR}/config.h 
           ${CMAKE_CURRENT_SOURCE_DIR}/enc/unicode/casefold.h 
           ${CMAKE_CURRENT_SOURCE_DIR}/onigmo.h 
           ${CMAKE_CURRENT_SOURCE_DIR}/onigmognu.h 
           ${CMAKE_CURRENT_SOURCE_DIR}/onigmoposix.h 
           ${CMAKE_CURRENT_SOURCE_DIR}/regenc.h 
           ${CMAKE_CURRENT_SOURCE_DIR}/regint.h 
           ${CMAKE_CURRENT_SOURCE_DIR}/regparse.h 
           ${CMAKE_CURRENT_SOURCE_DIR}/st.h 
           ${CMAKE_CURRENT_SOURCE_DIR}/win32/config.h 
           ${CMAKE_CURRENT_SOURCE_DIR}/config-onig-edbee.h
           PARENT_SCOPE
)

=== debian/changelog ===
mudlet (1:3.3.1-1) unstable; urgency=medium

  * New upstream release, Closes: #870208
  * Updated to standards version 4.0.0

 -- Craig Small <csmall@debian.org>  Sun, 06 Aug 2017 21:10:43 +1000

## mudlet 3.5.0

=== debian/changelog ===
mudlet (1:3.5.0-1) unstable; urgency=medium

  * New upstream release
  * Fix edebee compile error Closes: #871027
  * Update to standards 4.1.1 - no change

 -- Craig Small <csmall@debian.org>  Fri, 20 Oct 2017 22:45:23 +1100

=== debian/control ===
Source: mudlet
Section: games
Priority: extra
Maintainer: Craig Small <csmall@debian.org>
Build-Depends: debhelper (>= 9), pkg-config,
               libpcre3-dev, zlib1g-dev, libboost-dev, libyajl-dev,
               libhunspell-dev,
               qtbase5-dev, qt5-qmake, qttools5-dev, qtmultimedia5-dev,
               libqt5opengl5-dev,
               liblua5.1-dev, libzip-dev
Standards-Version: 4.1.1
Vcs-Git: git://anonscm.debian.org/collab-maint/mudlet.git
Vcs-Browser: http://anonscm.debian.org/gitweb/?p=collab-maint/mudlet.git
Homepage: http://www.mudlet.org/

Package: mudlet
Architecture: alpha amd64 arm64 hppa i386 ia64 m32r m68k mips mipsel powerpc ppc64 ppc64el s390 s390x sh3 sh3eb sparc sparc64 x32
Depends: ${shlibs:Depends}, ${misc:Depends},
         lua5.1-rex-pcre, lua5.1-sql-sqlite3,
         lua-filesystem, lua-zip
Suggests: hunspell-en-us
Description: Graphical MUD client with fast lua scripting support
 A completely redesigned MUD (Multi User Dungeon) client that is easy to
 use and customise.  Both power users and plain gamers alike will feel at
 home with Mudlet, without having to waste too much timer figuring out
 how to do something.
 . 
 Mudlet is designed to be very fast and efficient right from the start.
 Its scripting engine is designed to handle thousands of lines under
 one second. The scripting framework uses Lua - a small, fast and
 efficient scripting language.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-
# Sample debian/rules that uses debhelper.
# This file was originally written by Joey Hess and Craig Small.
# As a special exception, when this file is copied by dh-make into a
# dh-make output file, you may use that output file without restriction.
# This special exception was added by Craig Small in version 0.37 of dh-make.

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1
export QT_SELECT=5

PACKAGE=mudlet
SRC_VERSION:=$(shell dpkg-parsechangelog | sed -ne 's/^Version: \(\([0-9]\+\):\)\?\(.*\)-.*/\3/p')
TARBALL=$(PACKAGE)_$(SRC_VERSION).orig.tar.gz

%:
	dh $@ 

override_dh_auto_clean:
	[ ! -f src/Makefile ] || $(MAKE) -C src distclean

override_dh_auto_configure:
	cd src && qmake \
		DATAROOTDIR=/usr/share/games
		QMAKE_CFLAGS_RELEASE="$(shell dpkg-buildflags --get CPPFLAGS) $(shell dpkg-buildflags --get CFLAGS)" \
		QMAKE_CFLAGS_DEBUG="$(shell dpkg-buildflags --get CPPFLAGS) $(shell dpkg-buildflags --get CFLAGS)" \
		QMAKE_CXXFLAGS_RELEASE="$(shell dpkg-buildflags --get CPPFLAGS) $(shell dpkg-buildflags --get CFLAGS)" \
		QMAKE_CXXFLAGS_DEBUG="$(shell dpkg-buildflags --get CPPFLAGS) $(shell dpkg-buildflags --get CFLAGS)" \
		QMAKE_LFLAGS_RELEASE="$(shell dpkg-buildflags --get LDFLAGS)"  \
		QMAKE_LFLAGS_DEBUG="$(shell dpkg-buildflags --get LDFLAGS)" 

override_dh_auto_build:
	make -C src

override_dh_install:
	dh_install
	chmod a-x debian/mudlet/usr/share/games/mudlet/lua/*.lua
	chmod a-x debian/mudlet/usr/share/games/mudlet/lua/geyser/*.lua

get-orig-source:
	rm -rf get-orig-source $(TARBALL)
	mkdir -p get-orig-source/$(PACKAGE)-$(SRC_VERSION).orig
	wget -O get-orig-source/upstream.tgz "http://mudlet.git.sourceforge.net/git/gitweb.cgi?p=mudlet/mudlet;a=snapshot;h=HEAD;sf=tgz"
	cd get-orig-source && tar xfz upstream.tgz -C $(PACKAGE)-$(SRC_VERSION).orig --strip-components=1
	cd get-orig-source/$(PACKAGE)-$(SRC_VERSION).orig/src && \
		rm -rf yajl fonts hunspell en_US.aff en_US.dic
	tar cvfz $(TARBALL) -C get-orig-source $(PACKAGE)-$(SRC_VERSION).orig
	rm -rf get-orig-source
